package dev.shadowsoffire.apotheosis.adventure;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.common.base.Predicates;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.FestiveAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.MagicalArrowAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.OmneticAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.RadialAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.TelepathicAffix;
import dev.shadowsoffire.apotheosis.adventure.commands.AffixCommand;
import dev.shadowsoffire.apotheosis.adventure.commands.BossCommand;
import dev.shadowsoffire.apotheosis.adventure.commands.CategoryCheckCommand;
import dev.shadowsoffire.apotheosis.adventure.commands.GemCommand;
import dev.shadowsoffire.apotheosis.adventure.commands.LootifyCommand;
import dev.shadowsoffire.apotheosis.adventure.commands.ModifierCommand;
import dev.shadowsoffire.apotheosis.adventure.commands.RarityCommand;
import dev.shadowsoffire.apotheosis.adventure.commands.SocketCommand;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.placebo.events.AnvilLandEvent;
import dev.shadowsoffire.placebo.events.GetEnchantmentLevelEvent;
import dev.shadowsoffire.placebo.events.ItemUseEvent;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.function.Predicate;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.damagesource.DamageTypes;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.animal.AbstractGolem;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.projectile.Projectile;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.world.phys.AABB;
import net.minecraftforge.event.ItemAttributeModifierEvent;
import net.minecraftforge.event.entity.EntityJoinLevelEvent;
import net.minecraftforge.event.entity.ProjectileImpactEvent;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.event.entity.living.LivingHurtEvent;
import net.minecraftforge.event.entity.living.MobSpawnEvent;
import net.minecraftforge.event.entity.living.ShieldBlockEvent;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.event.level.BlockEvent;
import net.minecraftforge.eventbus.api.Event;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.eventbus.api.SubscribeEvent;

public class AdventureEvents {
  @SubscribeEvent
  public void cmds(Apotheosis.ApotheosisCommandEvent e) {
    RarityCommand.register(e.getRoot());
    CategoryCheckCommand.register(e.getRoot());
    LootifyCommand.register(e.getRoot());
    ModifierCommand.register(e.getRoot());
    GemCommand.register(e.getRoot());
    SocketCommand.register(e.getRoot());
    BossCommand.register(e.getRoot());
    AffixCommand.register(e.getRoot());
  }
  
  @SubscribeEvent
  public void affixModifiers(ItemAttributeModifierEvent e) {
    ItemStack stack = e.getItemStack();
    if (stack.m_41782_()) {
      Objects.requireNonNull(e);
      SocketHelper.getGems(stack).addModifiers(LootCategory.forItem(stack), e.getSlotType(), e::addModifier);
      Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(stack);
      affixes.forEach((afx, inst) -> {
            Objects.requireNonNull(e);
            inst.addModifiers(e.getSlotType(), e::addModifier);
          });
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.HIGH)
  public void preventBossSuffocate(LivingHurtEvent e) {
    if (e.getSource().m_276093_(DamageTypes.f_268612_) && e.getEntity().getPersistentData().m_128441_("apoth.boss"))
      e.setCanceled(true); 
  }
  
  @SubscribeEvent(priority = EventPriority.HIGH)
  public void fireArrow(EntityJoinLevelEvent e) {
    Entity entity = e.getEntity();
    if (entity instanceof AbstractArrow) {
      AbstractArrow arrow = (AbstractArrow)entity;
      if (!arrow.getPersistentData().m_128471_("apoth.generated")) {
        Entity entity1 = arrow.m_19749_();
        if (entity1 instanceof LivingEntity) {
          LivingEntity user = (LivingEntity)entity1;
          ItemStack bow = user.m_21211_();
          if (bow.m_41619_()) {
            bow = user.m_21205_();
            if (bow.m_41619_() || !LootCategory.forItem(bow).isRanged())
              bow = user.m_21206_(); 
          } 
          if (bow.m_41619_())
            return; 
          SocketHelper.getGems(bow).onArrowFired(user, arrow);
          AffixHelper.streamAffixes(bow).forEach(a -> a.onArrowFired(user, arrow));
          AffixHelper.copyFrom(bow, (Entity)arrow);
        } 
      } 
    } 
  }
  
  @SubscribeEvent
  public void impact(ProjectileImpactEvent e) {
    Projectile projectile = e.getProjectile();
    if (projectile instanceof AbstractArrow) {
      AbstractArrow arrow = (AbstractArrow)projectile;
      SocketHelper.getGemInstances(arrow).forEach(inst -> inst.onArrowImpact(arrow, e.getRayTraceResult()));
      Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(arrow);
      affixes.values().forEach(inst -> inst.onArrowImpact(arrow, e.getRayTraceResult(), e.getRayTraceResult().m_6662_()));
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void onDamage(LivingHurtEvent e) {
    Apoth.Affixes.MAGICAL.getOptional().ifPresent(afx -> afx.onHurt(e));
    DamageSource src = e.getSource();
    LivingEntity ent = e.getEntity();
    float amount = e.getAmount();
    for (ItemStack s : ent.m_20158_()) {
      amount = SocketHelper.getGems(s).onHurt(src, ent, amount);
      Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(s);
      for (AffixInstance inst : affixes.values())
        amount = inst.onHurt(src, ent, amount); 
    } 
    e.setAmount(amount);
  }
  
  @SubscribeEvent
  public void onItemUse(ItemUseEvent e) {
    ItemStack s = e.getItemStack();
    InteractionResult socketRes = SocketHelper.getGems(s).onItemUse(e.getContext());
    if (socketRes != null) {
      e.setCanceled(true);
      e.setCancellationResult(socketRes);
    } 
    InteractionResult afxRes = AffixHelper.streamAffixes(s).map(afx -> afx.onItemUse(e.getContext())).filter(Predicates.notNull()).findFirst().orElse(null);
    if (afxRes != null) {
      e.setCanceled(true);
      e.setCancellationResult(afxRes);
    } 
  }
  
  @SubscribeEvent
  public void shieldBlock(ShieldBlockEvent e) {
    ItemStack stack = e.getEntity().m_21211_();
    Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(stack);
    float blocked = e.getBlockedDamage();
    blocked = SocketHelper.getGems(stack).onShieldBlock(e.getEntity(), e.getDamageSource(), blocked);
    for (AffixInstance inst : affixes.values())
      blocked = inst.onShieldBlock(e.getEntity(), e.getDamageSource(), blocked); 
    if (blocked != e.getOriginalBlockedDamage())
      e.setBlockedDamage(blocked); 
  }
  
  @SubscribeEvent
  public void blockBreak(BlockEvent.BreakEvent e) {
    ItemStack stack = e.getPlayer().m_21205_();
    SocketHelper.getGems(stack).onBlockBreak(e.getPlayer(), e.getLevel(), e.getPos(), e.getState());
    AffixHelper.streamAffixes(stack).forEach(inst -> inst.onBlockBreak(e.getPlayer(), e.getLevel(), e.getPos(), e.getState()));
  }
  
  @SubscribeEvent(priority = EventPriority.HIGH)
  public void dropsHigh(LivingDropsEvent e) {
    Entity entity = e.getSource().m_7639_();
    if (entity instanceof ServerPlayer) {
      ServerPlayer p = (ServerPlayer)entity;
      if (e.getEntity() instanceof net.minecraft.world.entity.monster.Monster) {
        if (p instanceof net.minecraftforge.common.util.FakePlayer)
          return; 
        float chance = AdventureConfig.gemDropChance + (e.getEntity().getPersistentData().m_128441_("apoth.boss") ? AdventureConfig.gemBossBonus : 0.0F);
        if (p.f_19796_.m_188501_() <= chance) {
          LivingEntity livingEntity = e.getEntity();
          e.getDrops()
            .add(new ItemEntity(livingEntity.m_9236_(), livingEntity.m_20185_(), livingEntity.m_20186_(), livingEntity.m_20189_(), GemRegistry.createRandomGemStack(p.f_19796_, (ServerLevel)p.m_9236_(), p.m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches(p.m_9236_()), GameStagesCompat.IStaged.matches((Player)p) }), 0.0D, 0.0D, 0.0D));
        } 
      } 
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void drops(LivingDropsEvent e) {
    Apoth.Affixes.FESTIVE.getOptional().ifPresent(afx -> afx.drops(e));
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void deathMark(LivingDeathEvent e) {
    Apoth.Affixes.FESTIVE.getOptional().ifPresent(afx -> afx.markEquipment(e));
  }
  
  @SubscribeEvent(priority = EventPriority.LOWEST)
  public void dropsLowest(LivingDropsEvent e) {
    TelepathicAffix.drops(e);
  }
  
  @SubscribeEvent(priority = EventPriority.LOWEST, receiveCanceled = true)
  public void festive_removeMarker(LivingDropsEvent e) {
    Apoth.Affixes.FESTIVE.getOptional().ifPresent(afx -> afx.removeMarker(e));
  }
  
  @SubscribeEvent
  public void harvest(PlayerEvent.HarvestCheck e) {
    Apoth.Affixes.OMNETIC.getOptional().ifPresent(afx -> afx.harvest(e));
  }
  
  @SubscribeEvent(priority = EventPriority.HIGHEST)
  public void speed(PlayerEvent.BreakSpeed e) {
    Apoth.Affixes.OMNETIC.getOptional().ifPresent(afx -> afx.speed(e));
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void onBreak(BlockEvent.BreakEvent e) {
    Apoth.Affixes.RADIAL.getOptional().ifPresent(afx -> afx.onBreak(e));
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void special(MobSpawnEvent.FinalizeSpawn e) {
    if (e.getSpawnType() == MobSpawnType.NATURAL && e.getLevel().m_213780_().m_188501_() <= AdventureConfig.randomAffixItem && e.getEntity() instanceof net.minecraft.world.entity.monster.Monster) {
      Player player = e.getLevel().m_45924_(e.getX(), e.getY(), e.getZ(), -1.0D, false);
      if (player == null)
        return; 
      ItemStack affixItem = LootController.createRandomLootItem(e.getLevel().m_213780_(), null, player, (ServerLevelAccessor)e.getEntity().m_9236_());
      if (affixItem.m_41619_())
        return; 
      affixItem.m_41784_().m_128379_("apoth_rspawn", true);
      LootCategory cat = LootCategory.forItem(affixItem);
      EquipmentSlot slot = cat.getSlots()[0];
      e.getEntity().m_8061_(slot, affixItem);
      e.getEntity().m_21508_(slot);
    } 
  }
  
  @SubscribeEvent
  public void gemSmashing(AnvilLandEvent e) {
    Level level = e.getLevel();
    BlockPos pos = e.getPos();
    List<ItemEntity> items = level.m_45976_(ItemEntity.class, new AABB(pos, pos.m_7918_(1, 1, 1)));
    for (ItemEntity ent : items) {
      ItemStack stack = ent.m_32055_();
      if (stack.m_41720_() == Adventure.Items.GEM.get())
        ent.m_32045_(new ItemStack((ItemLike)Adventure.Items.GEM_DUST.get(), stack.m_41613_())); 
    } 
  }
  
  private static ThreadLocal<AtomicBoolean> reentrantLock = ThreadLocal.withInitial(() -> new AtomicBoolean(false));
  
  @SubscribeEvent(priority = EventPriority.HIGH)
  public void enchLevels(GetEnchantmentLevelEvent e) {
    boolean isReentrant = ((AtomicBoolean)reentrantLock.get()).getAndSet(true);
    if (isReentrant)
      return; 
    SocketHelper.getGems(e.getStack()).getEnchantmentLevels(e.getEnchantments());
    AffixHelper.streamAffixes(e.getStack()).forEach(inst -> inst.getEnchantmentLevels(e.getEnchantments()));
    ((AtomicBoolean)reentrantLock.get()).set(false);
  }
  
  @SubscribeEvent
  public void update(LivingEvent.LivingTickEvent e) {
    LivingEntity entity = e.getEntity();
    if (entity.getPersistentData().m_128441_("apoth.burns_in_sun"))
      if (entity.m_9236_().m_46461_() && !(entity.m_9236_()).f_46443_) {
        float f = entity.m_213856_();
        BlockPos blockpos = BlockPos.m_274561_(entity.m_20185_(), entity.m_20188_(), entity.m_20189_());
        boolean flag = (entity.m_20071_() || entity.f_146808_ || entity.f_146809_);
        if (f > 0.5F && entity.f_19796_.m_188501_() * 30.0F < (f - 0.4F) * 2.0F && !flag && entity.m_9236_().m_45527_(blockpos))
          entity.m_20254_(8); 
      }  
  }
  
  @SubscribeEvent
  public void despawn(MobSpawnEvent.AllowDespawn e) {
    Mob mob = e.getEntity();
    if (mob instanceof AbstractGolem) {
      AbstractGolem g = (AbstractGolem)mob;
      if (g.f_19797_ > 12000 && g.getPersistentData().m_128471_("apoth.boss")) {
        Player player = g.m_9236_().m_45930_((Entity)g, -1.0D);
        if (player != null) {
          double dist = player.m_20280_((Entity)g);
          int despawnDist = g.m_6095_().m_20674_().m_21611_();
          int dsDistSq = despawnDist * despawnDist;
          if (dist > dsDistSq)
            e.setResult(Event.Result.ALLOW); 
        } 
      } 
    } 
  }
  
  @SubscribeEvent
  public void clone(PlayerEvent.Clone e) {
    int oldSeed = e.getOriginal().getPersistentData().m_128451_("apoth_reforge_seed");
    e.getEntity().getPersistentData().m_128405_("apoth_reforge_seed", oldSeed);
  }
}
